/* $Id: nws_dc_array.h,v 1.3 2002/03/12 15:53:35 mquinson Exp $ */

/* nws_dc_array - data container of type (flat) array                        */

/*   this file is the internal interface, needed by nws_cache.c to register  */
/*   the array type to the table of possible datacontainer types             */

#ifndef __NWS_DC_ARRAY_H
#define __NWS_DC_ARRAY_H

/*====[ Array type datacontainer ]===========================================*/
typedef struct {
  nwsDcKey_t key; 
  nwsDcCell_t *cell;
} nwsDcCellArray_t;

typedef struct {
  nwsDcCellArray_t *data;
  int dataCount;
  int maxSize;
} nwsDcArray_ctn;

typedef int nwsDcCursorArray_ctn;
/*====[ functions to interface with this type ]==============================*/
/* nws_cache.c store them in the #functions# array, and they should be       */
/*  accessed from client code only through nwsDc* generic functions          */
/*===========================================================================*/
int nwsDcArrayAdd(nwsDc_t*self,nwsDcKey_t key,nwsDcCell_t* elem);
int nwsDcArrayRemove(nwsDc_t*self,nwsDcCursor_t *cursor);
int nwsDcArrayRetrieve(nwsDc_t*self,nwsDcKey_t key,
		       /*OUT*/nwsDcCursor_t*where);
int nwsDcArrayCommit(nwsDc_t*self);
int nwsDcArrayFree(nwsDc_t *self); /* Desctructor */
/* for traversal */
int nwsDcArrayCursorInit(nwsDc_t*self,/*OUT*/nwsDcCursor_t *where);
int nwsDcArrayCursorNext(/*IN&OUT*/nwsDcCursor_t *cursor,
			 /*OUT*/nwsDcKey_t *key,nwsDcCell_t**data);
int nwsDcArrayCursorFree(nwsDcCursor_t *cursor);
/* to debug */
int nwsDcArrayDump(nwsDc_t*self,void (*dumpFct)(void*data));

/* Constructor is in nws_cache.h, to be visible from client code */


#endif /* __NWS_DC_ARRAY_H */
