/* $Id: nws_dc_list.h,v 1.1 2002/03/12 15:53:35 mquinson Exp $ */

/* nws_dc_list - data container of type (simply) linked list                 */

/*   this file is the internal interface, needed by nws_cache.c to register  */
/*   the array type to the table of possible datacontainer types             */

#ifndef __NWS_DC_LIST_H
#define __NWS_DC_LIST_H

/*====[ List type datacontainer ]===========================================*/
typedef struct nwsDcCellList_ nwsDcCellList_t;
struct nwsDcCellList_{
  nwsDcKey_t key; 
  nwsDcCell_t *cell;
  nwsDcCellList_t *prev,*next;
};

typedef struct {
  nwsDcCellList_t *head;
} nwsDcList_ctn;

typedef struct {
  nwsDcCellList_t *this;
} nwsDcCursorList_ctn;
/*====[ functions to interface with this type ]==============================*/
/* nws_cache.c store them in the #functions# array, and they should be       */
/*  accessed from client code only through nwsDc* generic functions          */
/*===========================================================================*/
int nwsDcListAdd(nwsDc_t*self,nwsDcKey_t key,nwsDcCell_t* elem);
int nwsDcListRemove(nwsDc_t*self,nwsDcCursor_t *cursor);
int nwsDcListRetrieve(nwsDc_t*self,nwsDcKey_t key,
		      /*OUT*/nwsDcCursor_t*cursor);
int nwsDcListCommit(nwsDc_t*self);
int nwsDcListFree(nwsDc_t *self); /* Desctructor */
/* for traversal */
int nwsDcListCursorInit(nwsDc_t*self,/*OUT*/nwsDcCursor_t *where);
int nwsDcListCursorNext(/*IN&OUT*/nwsDcCursor_t *cursor,
			 /*OUT*/nwsDcKey_t *key,nwsDcCell_t**data);
int nwsDcListCursorFree(nwsDcCursor_t *cursor);
/* to debug */
int nwsDcListDump(nwsDc_t*self,void (*dumpFct)(void*data));

/* Constructor is in nws_cache.h, to be visible from client code */


#endif /* __NWS_DC_LIST_H */
