#!/usr/bin/perl -w

use strict;

my %files=();

my $debug = 0;
sub parse_file {
    my $filename=shift;
    
    print "PARSE $filename\n" if $debug;
    open NM,("nm -l $filename|sort |") || die "can't exec nm";
    my $i=1;
    while (my $line=<NM>) {
	chomp($line);
	next if $line =~ /^[[:blank:]]/;
	$line =~ /^0([0-9a-f]*) . (\w*)/ || die "Don't understand nm output:\n$line\n";
	$files{"$filename"}[$i] = "$1!$2";
	print "$i: ".$files{"$filename"}[$i]."\n" if $debug >1;
	$i++;
    }
    $files{"$filename"}[0]=$i;
    close NM || die "Can't close nm";
}

sub print_function {
    my $filename=shift;
    my $addr=shift;

    my $lastaddr="";
    my $lastfunc="";

    print "search $addr in $filename\n" if $debug;
    parse_file($filename) unless defined($files{"$filename"});
    for (my $i=1; $i < $files{"$filename"}[0] ; $i++) {
	$files{"$filename"}[$i] =~ /^(.*?)!(.*?)$/ 
	    || die "internal error:".$files{"$filename"}[$i]."\n";
	my ($nextaddr,$nextfunc)=($1,$2);
	if (hex ("0x".$nextaddr) > hex $addr) {
	    print "$filename: $lastfunc() at 0x$lastaddr\n";
	    return;
	}
	$lastaddr = $nextaddr;
	$lastfunc = $nextfunc;
    }
    exit 0;
}
    
while (<>) {
    die "Sorry, I don't understand your backtrace. Please copy it exactly.\n".
	"Offending line:\n".$_."\n"
	unless     /^([^ (]*)[ (].*?\[([^\]]*)\].*$/;

    print_function($1,$2);
}
