#include "nws_log.h"

NWS_LOG_DECLARE(test_log,"v=stdout,d=stdout,warn=0,err=0");
NWS_LOG_DECLARE(test2_log,"verbose=0");

NWS_LOG_USE(log);  /* I change it to open it fully */

/* to test the backtrace */
void sub(void); void sub1(void);void sub2(void); void sub3(void); 
void sub4(void); void sub5(void);

void sub5(){NWS_BACKTRACE(test_log,LogDebug);}
void sub4(){sub5();}
void sub3(){sub4();}
void sub2(){sub3();}
void sub1(){sub2();}
void sub(){sub1();}

int main(){
  int fake_argc=1;
  const char * fake_argv[1]={"--log=test_log:warn=0"};

  NWS_WARN(test_log)("Log subsystem default settings OK");
  nws_log_init(&fake_argc,fake_argv);
  NWS_WARN(test_log)("User setting trough nws_log_init() BROKEN");
  NWS_LOG_PARSE_OPTION("test_log:warn=0");
  NWS_WARN(test_log)("Setting trough PARSE_OPTION BROKEN");
  NWS_DEBUG(test2_log)("Second channel test OK");
  
  /* verify that all errors are traped by parse option */
  __nws_log_parse_option(NULL,"log:*=0,e=0");
  __nws_log_parse_option(NULL,"test_log:*=1");

  /* test channel name */
  NWS_DEBUG(test_log)("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX Test the option parsing mecanism");
  if (__nws_log_parse_option(NULL,"azerty:e=1") != NWSERR_PARSE)
    NWS_ERROR(test_log)("nws_log_parse_option DONT trap non existant channel");
  else
    NWS_DEBUG(test_log)("nws_log_parse_option traps non existant channel %s",
			"azerty");
    
  if (__nws_log_parse_option(NULL,"e=1") != NWSERR_PARSE)
    NWS_ERROR(test_log)("nws_log_parse_option DONT trap NULL channel");
  else
    NWS_DEBUG(test_log)("nws_log_parse_option traps NULL channel");

  if (__nws_log_parse_option(NULL,"*:e=1") != NWSERR_PARSE)
    NWS_ERROR(test_log)("nws_log_parse_option DONT trap multi-channels");
  else
    NWS_DEBUG(test_log)("nws_log_parse_option traps multi-channels");

  /* test level */
  if (__nws_log_parse_option(NULL,"test2_log:azerty=1") != NWSERR_PARSE)
    NWS_ERROR(test_log)("nws_log_parse_option DONT trap non existant level");
  else
    NWS_DEBUG(test_log)("nws_log_parse_option traps non existant level");

  if (__nws_log_parse_option(NULL,"test2_log:=1") != NWSERR_PARSE)
    NWS_ERROR(test_log)("nws_log_parse_option DONT trap NULL level");
  else
    NWS_DEBUG(test_log)("nws_log_parse_option traps NULL level");

  /* both level and channel */
  if (__nws_log_parse_option(NULL,"=1") != NWSERR_PARSE)
    NWS_ERROR(test_log)("nws_log_parse_option DONT trap NULL level and channel");
  else
    NWS_DEBUG(test_log)("nws_log_parse_option traps NULL level and channel");


  /* test values */
  if (__nws_log_parse_option(NULL,"test2_log:e*") != NWSERR_PARSE)
    NWS_ERROR(test_log)("nws_log_parse_option DONT trap NULL value");
  else
    NWS_DEBUG(test_log)("nws_log_parse_option traps NULL value");

  if (__nws_log_parse_option(NULL,"test2_log:e*=azerty") != NWSERR_PARSE)
    NWS_ERROR(test_log)("nws_log_parse_option DONT trap erroneous values");
  else
    NWS_DEBUG(test_log)("nws_log_parse_option traps erroneous values");

  sub(); /* test of backtrace */
  return 0;
}
